#define AIN1 60
#define AIN2 58
#define DIN 211
#define DOUT 81

//DIGITAL OUT PINS 0 - 7 CLAB
byte Douts[] = {10,11,12,13,  16,17,18,19};
//DIGITAL IN  PINS 0 - 7 CLAB
byte Dins[]  = { 2, 3, 4, 5,   6, 7, 8, 9}; 
//ANALOG IN PINS A - B CLAB
byte Ains[]  = {0,1}; 
//BitValues
byte Bits[]  = {1,2,4,8,16,32,64,128};


void setup()
{ Serial.begin(9600); //Special CLAB
  for(int i= 0;i<8;i++)pinMode(Douts[i],OUTPUT);
  for(int i= 0;i<2;i++)pinMode(Ains [i],INPUT);
  for(int i= 0;i<8;i++)
  {pinMode(Dins [i],INPUT);// OPEN IS HIGH
   digitalWrite(Dins[i],HIGH); //WITH PULLUP 
  }
}

void loop()
{ int i, val, inbyte; byte b;
  val = Serial.available(); //Was da?
  if (val>0)
  {inbyte=Serial.read(); //abholen
   delay(5);
   switch(inbyte)
  { case 13  : //CLAB ID nur bei Compact 1.75!
               Serial.write(2);delay(2);break; //ID
    case DIN : for(i=0,b=0;i<8;i++) //PINS to BYTE
                b+= (digitalRead(Dins[i])==HIGH?Bits[i]:0);
               Serial.write(b);break; 
    case AIN1: Serial.write(analogRead(Ains[0])>>2);break;
    case AIN2: Serial.write(analogRead(Ains[1])>>2);break;
    case DOUT: b=Serial.read(); //Ausgabebyte holen
               for(i=0;i<8;i++)
                digitalWrite(Douts[i],b&Bits[i]?HIGH:LOW);
               break;
    default:   break;
  }
 }
 delay(10);
}
